import { mergeHooks } from './utils';
import { LoggerT, hookFnT, configHooksT, deprecatedHookT, deprecatedHooksT } from './types';
declare class Hookable {
    private _hooks;
    private _deprecatedHooks;
    private _logger;
    static mergeHooks: typeof mergeHooks;
    mergeHooks: typeof mergeHooks;
    constructor(logger?: LoggerT | false);
    hook(name: string, fn: hookFnT): () => void;
    hookOnce(name: string, fn: hookFnT): any;
    removeHook(name: string, fn: hookFnT): void;
    deprecateHook(name: string, deprecated: deprecatedHookT): void;
    deprecateHooks(deprecatedHooks: deprecatedHooksT): void;
    addHooks(configHooks: configHooksT): () => void;
    removeHooks(configHooks: configHooksT): void;
    callHook(name: string, ...args: any): Promise<void>;
}
export default Hookable;
